<?php

/**
 * com_trans_contratado actions.
 *
 * @package    controlComisiones
 * @subpackage com_trans_contratado
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class com_trans_contratadoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_TRANS_CONTRATADO',
        'COM_TIPO_VEHICULO',
        'COM_TIPO_SERVICIO',
        'MUNICIPIOS',
        'DEPARTAMENTO',
        'COM_TRANS_CONTRATADO_PROG'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_TIPO_VEHICULO, LEFT' =>
        array(
            'id_tipo_vehiculo' => 'COM_TRANS_CONTRATADO'
        ),
        'COM_TIPO_SERVICIO, LEFT' =>
        array(
            'id_tipo_servicio' => 'COM_TRANS_CONTRATADO'
        ),
        'MUNICIPIOS' =>
        array(
            'codmun_origen-codmun' => 'COM_TRANS_CONTRATADO'
        ),
        'DEPARTAMENTO' =>
        array(
            'id_depto_origen-id_depto' => 'COM_TRANS_CONTRATADO'
        ),
        'COM_TRANS_CONTRATADO_PROG, LEFT' =>
        array(
            'id_trans_contratado' => 'COM_TRANS_CONTRATADO'
        ),
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_TRANS_CONTRATADO' =>
        array(
            'id_trans_contratado' => 'id_trans_contratado',
            'id_plan_comisiones' => 'id_plan_comisiones',
            'vigencia' => 'vigencia',
            'estado' => 'estado',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log',
            'num_solicitud' => 'num_solicitud',
            'codmun_origen' => 'codmun_origen',
            'id_depto_origen' => 'id_depto_origen',
            'inicio_ruta' => 'inicio_ruta',
            'fecha_salida' => 'fecha_salida',
            'hora_salida' => 'hora_salida',
            'fecha_llegada' => 'fecha_llegada',
            'hora_llegada' => 'hora_llegada',
            'total_dias' => 'total_dias',
            'id_tipo_vehiculo' => 'id_tipo_vehiculo',
            'traslada_equipos' => 'traslada_equipos',
            'id_tipo_servicio' => 'tipo_servicio',
            'id_tipo_servicio' => 'id_tipo_servicio',
            'id_coordinador_zonal' => 'id_coordinador_zonal',
            'observaciones' => 'observaciones',
            'pernocta' => 'pernocta',
            'id_clasif_comision' => 'id_clasif_comision',
        ),
        'COM_TIPO_VEHICULO' =>
        array(
            'descripcion' => 'descripcion_vehiculo',
        ),
        'COM_TIPO_SERVICIO' =>
        array(
            'descripcion' => 'descripcion_servicio',
        ),
        'MUNICIPIOS' =>
        array(
            'municipio' => 'municipio_origen',
        ),
        'DEPARTAMENTO' =>
        array(
            'descripcion' => 'departamento_origen',
        ),
        'COM_TRANS_CONTRATADO_PROG' =>
        array(
            'estado_prog' => 'estado_prog',
        ),
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * _filtroNull / para filtro de not null o null - type debe ser is - para todas las variables
     * TYPE NULL / para filtro de not null o null con el valor de campo desde gwt
     * EJEMPLO: 'titular' => array('NULL' => array('titular')),
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_TRANS_CONTRATADO' => array(
            'id_trans_contratado,a' => array('!=' => array(-1)),
            'id_trans_contratado,b' => array('=' => array('id_trans_contratado')),
            'vigencia' => array('=' => array('vigencia')),
            'usuario_log' => array('=' => array('usuario_log')),
            'id_plan_comisiones' => array('=' => array('id_plan_comisiones')),
            'id_clasif_comision' => array('=' => array('id_clasif_comision')),
            'fecha_log' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'COM_TRANS_CONTRATADO_PROG' => array(
            'estado_prog' => array('IN' => array('estado_general')),
        ),
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
//    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas
    protected $fields_orderBy = array(
        'id_trans_contratado'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_trans_contratado'; //identificador de la tabla - solo si es un dato no llave compuesta
    protected $id_names = array('id_trans_contratado'); //llave primaria
    protected $field_names = array('id_plan_comisiones', 'vigencia', 'estado', 'fecha_log', 'usuario_log',
        'num_solicitud', 'codmun_origen', 'id_depto_origen', 'inicio_ruta', 'fecha_salida', 'hora_salida', 'fecha_llegada', 'hora_llegada',
        'total_dias', 'id_tipo_vehiculo', 'traslada_equipos', 'id_tipo_servicio', 'id_coordinador_zonal', 'observaciones', 'pernocta', 'id_clasif_comision'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_TRANS_CONTRATADO'; //tabla en la cual se aplican los cambios
    protected $has_activo = false; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * campos para fecha sistema
     */
//    protected $campo_fecha_sistema = array(
//        'fecha_crea'
//    );

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_trans_contratado'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         * Variables request
         */
        /*
         * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
         */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        foreach ($array as $routeName => $routeData) {
            //echo $routeName . "\n";
            if ('entidad_cliente' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $entidadCliente = $value;
                    }
                }
            }
            if ('entidad_nombre' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $entidadNombre = $value;
                    }
                }
            }
            $int++;
        }

        if (isset($request['bandera_editar']) && isset($request['estado']) && $entidadCliente == 2) {

            $id_trans_contratado = $request['id_trans_contratado'];
            /*
             *  Validar la operación, ya sea por SQL
             */
            $sql = <<<EOD
select * 
from com_trans_contra_pasajero
where
id_trans_contratado = $id_trans_contratado
EOD;
            $records = CN_TABLE::executeSQL($sql);
            /*
             *  Generar errores en $errors
             */
            if (count($records) <= 0) {
                $errors['mensaje'] = "La Solicitud necesita añadir pasajeros";
                $errors['servicio'] = "com_trans_contratado";
            }
        }

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
            $sql = <<<EOD
select 
nvl(max(num_solicitud),0) + 1 as numero 
from  com_trans_contratado
where 
EXTRACT(MONTH from fecha_log) = EXTRACT(MONTH from SYSDATE)
and EXTRACT(YEAR from fecha_log) = EXTRACT(YEAR from SYSDATE) 
EOD;
            $result = CN_TABLE::executeSQL($sql);
            
            $request['num_solicitud'] = $result[0]['numero'];
            
            $request['fecha_log'] = CN_TABLE::fechaSistema();
            $request['usuario_log'] = $request['id_username'];
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //Asignamos al transporte contratado todos los destinos del plan de comision
            //obtenemos variables
            $id_pan_comisiones = $request['id_plan_comisiones'];
            $vigencia = $request['vigencia'];
            $id_trans_contratado = $list_data_post[0]['id_trans_contratado'];

            //Creamos conexion
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            $sql = <<<EOD
Insert into COM_TRANS_CONTRA_DESTINO(ID_TRANS_CONTRATADO,CODMUN,ORDEN,ESTADO,ID_DEPTO)
select 
    $id_trans_contratado,codmun,orden,1,id_depto 
from 
    com_plan_destinos
where 
    ID_PLAN_COMISIONES = $id_pan_comisiones
    and vigencia = $vigencia
EOD;

            //ejecut6ar sql
            $this->conn->execute($sql);
            $this->conn->commit();
        }

        //accion update
        if ($Action == "UPDATE") {

            /*
             * Se instancia la clase del manejo del log
             */
            $logger = sfContext::getInstance()->getLogger();
            $logger->info("Entro a ValidateUpdate");
            /*
             * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
             */
            $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

            $int = 0;
            foreach ($array as $routeName => $routeData) {
                //echo $routeName . "\n";
                if ('entidad_cliente' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $entidadCliente = $value;
                        }
                    }
                }
                if ('entidad_nombre' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $entidadNombre = $value;
                        }
                    }
                }
                if ('correoEnvio' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $correoEnvio = $value;
                        }
                    }
                }
                /*  if ('jasper_url' == $routeName) {
                  foreach ($routeData as $key => $value) {
                  //echo $value . "\n";
                  if ($key == 'value') {
                  $url_jasper = $value;
                  }
                  }
                  } */
                $int++;
            }


            if (isset($request['bandera_editar']) && isset($request['estado']) && ($entidadCliente == 2 || $entidadCliente == 3)) {

                if ($request['bandera_editar'] == 1 && $request['estado'] == 0 && ($entidadCliente == 2 || $entidadCliente == 3)) {

                    $logger->info("Envio correo a los comisionados.");
                    
                    $tag_entidad = '';
                    if($entidadCliente != 2) {
                        $tag_entidad = '- SGR';
                    }

                    $id_plan_comisiones = $request['id_plan_comisiones'];
                    $id_trans_contratado = $request['id_trans_contratado'];

                    $sql = <<<EOD
SELECT
cont.num_solicitud,
cont.vigencia,
cont.id_clasif_comision,
to_char(cont.fecha_salida,'dd/mm/yyyy') as fecha_salida,
to_char(cont.fecha_llegada,'dd/mm/yyyy') as fecha_llegada,
cont.inicio_ruta,
pas.*
FROM com_trans_contra_pasajero pas

left join com_trans_contratado cont
on cont.id_trans_contratado = pas.id_trans_contratado

where
pas.id_trans_contratado = $id_trans_contratado  
EOD;
                    $result = CN_TABLE::executeSQL($sql);
                    $id_clasif_comision = 1;
                    $solicitud = "";
                    $solicitud_text = "Transporte";
                    $vigencia = 0;
                    

                    if (count($result) > 0) {
                        $id_clasif_comision = $result[0]['id_clasif_comision'];
                        $solicitud = $result[0]['num_solicitud'];
                        if ($id_clasif_comision != 1) {
                            $solicitud_text = "Tiquete Aereo";
                        }
                        $vigencia = $result[0]['vigencia'];
                        $fecha_salida_trans = $result[0]['fecha_salida'];
                        $fecha_llegada_trans = $result[0]['fecha_llegada'];
                        $itinerario = $result[0]['inicio_ruta'];
                    }


                    $sql = <<<EOD
SELECT 
tab0.id_plan_comisiones ||'-'|| tab0.vigencia ||'-'|| tab0.descomi as completo_planea,
tab1.email,
tab1.razsoc,                                    
tab0.nitocc, 
tab0.nitocc as num_doc, 
'$correoEnvio' as email_envio,

'Por medio del presente correo nos permitimos informarle que ha sido registrada la solicitud de $solicitud_text N° ($solicitud) de la planeación (' || tab0.id_plan_comisiones ||'-'|| tab0.vigencia ||').<br/> Fecha salida prevista $fecha_salida_trans <br/> Fecha regreso prevista $fecha_llegada_trans <br/> Itinerario: $itinerario'  as mensaje_extra,

'' as mensaje,
'' as mensaje_firma   

FROM COM_PLAN_COMISIONES_V tab0

left JOIN TERCEROS tab1 ON to_char(tab0.nitocc)=to_char(tab1.nitocc)                              

WHERE 
1=1 
AND tab0.id_plan_comisiones = $id_plan_comisiones  
and tab0.vigencia = $vigencia                            
EOD;
                    $result = CN_TABLE::executeSQL($sql);


                    $planeacion = "" . $result[0]['completo_planea'];


                    $subject = "ASUNTO: SOLICITUD TRANSPORTE CONTRATADO $tag_entidad";
                    $reporteAdjuntos = 'list_trans_contratado';
                    $nombreArchivo = "solicitud_transporte_$id_plan_comisiones"."_$vigencia";
                    if ($id_clasif_comision != 1) {
                        $subject = "ASUNTO: CIERRE SOLICITUD TIQUETE AEREO $tag_entidad";
                        $reporteAdjuntos = 'list_trans_contratado_ta';
                        $nombreArchivo = "solicitud_tiquetet_aereo_$id_plan_comisiones"."_$vigencia";
                    }

                    $emailp = $result[0]['email'];

                    $report_params['mensaje'] = $result[0]['mensaje_extra'];
                    //$prefijo = $records[0]['prefijo'];
                    $mensaje_extra = $result[0]['mensaje_extra'];
                    $logger->info("Mensaje Correo $subject: $mensaje_extra");

                    //Ejemplo de la persona que se envia el correo: 
                    //123;1;pepito perez;correo@gmal.com
                    //DATOS RESPONSABLE
                    $num_doc = $result[0]['num_doc'];
                    $id_tipo_doc = 1;
                    $razon_soc = $result[0]['razsoc'];
                    $correo = 'paola.velasco@anm.gov.co';
                    $datos_usuario = array(
                        '0' => $num_doc . ';' . $id_tipo_doc . ';' . $razon_soc . ';' . $correo,
                        '1' => '0;1;maria.cuenca;maria.cuenca@anm.gov.co',// 20250528 ARANDA OTI-IM-153 :: DORTEGA
                    );

                    $currentUri = '';

                    $adjunto = true;
                    $progress_key = $request['comando'] . $request['username'];

                    $entidad_cliente = $entidadCliente;
                    $entidad_nombre = $entidadNombre;
                    $addAddress = true;
                    //generamos adjuntos PDF
                    $this->generarAdjuntos($id_plan_comisiones,$vigencia,$id_clasif_comision,$reporteAdjuntos,$nombreArchivo);
                    $ruta = getcwd() . "/uploads/";
                    $array_adjuntos = array(
                        "$nombreArchivo.pdf" => "solicitud_transporte/$nombreArchivo.pdf",
                        //"$nombreArchivo.xls" => "solicitud_transporte/$nombreArchivo.xls"
                    );
                    $logger->info("Adjuntado archivo: $ruta solicitud_transporte/$nombreArchivo.pdf");
                    
                    $logger->info("Subject: " . $subject);

                    CN_TABLE::envioCorreo($report_params, $datos_usuario, $subject, $currentUri, $ruta, $adjunto, $progress_key, $array_adjuntos, $entidad_cliente, $entidad_nombre, $addAddress);
                }
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }
    private function generarAdjuntos($id_plan_comisiones,$vigencia,$id_clasif_comision,$reporte,$nombreArchivo)
    {
        /*
        * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
        */
        $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

        $int = 0;
        foreach ($array as $routeName => $routeData) {
           if ('jasper_url' == $routeName) {
               foreach ($routeData as $key => $value) {
                   //echo $value . "\n";
                   if ($key == 'value') {
                       $url_jasper = $value;
                   }
               }
           }
           //$url_presup = "http://10.0.100.66/presupuesto/web/index.php/pr_resolucion_comis/";
           $int++;
        }
        
        //QUITAMOS GUIONES DEL NOMBRE NO PERMITIDOS POR EL PROBEEDOR ANDES
        /*$arrayNombre = explode("-", $nombreArchivo);
        $nombreArchivo = implode("",$arrayNombre);
        $nombre_reporte = $nombreArchivo . ".pdf";*/
        $this->logMessage("Archivo a firmar :" . $nombreArchivo);
        // Generamos PDF JASPER PDF
        $url = $url_jasper;
        $url = $url . "$reporte&format=PDF&PARAM_id_mod=24&PARAM_username=websafi&PARAM_nitocc=800189921&PARAM_id_username=946";
        $url = $url . "&PARAM_id_plan_comisiones=$id_plan_comisiones";
        $url = $url . "&PARAM_vigencia=$vigencia";
        $url = $url . '&PARAM_envio_correo=false&PARAM_tag_adjunto_modulo=true';
        $url = $url . '&PARAM_nombre_reporte=' . str_replace(' ', ':', "$nombreArchivo.pdf");
        $this->logMessage($url);
        $ch = curl_init($url);
        //Parametros de retorno en cURL
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); // Skip SSL Verification - 20200407::LAVILA
        //Ejecuta la petición
        $rta = curl_exec($ch);
        //Se cierra la conexión
        curl_close($ch);
        // Generamos jasper XLS
        /*$url = $url_jasper;
        $url = $url . "$reporte&format=XLS&PARAM_id_mod=24&PARAM_username=websafi&PARAM_nitocc=800189921&PARAM_id_username=946";
        $url = $url . "&PARAM_id_plan_comisiones=$id_plan_comisiones";
        $url = $url . "&PARAM_vigencia=$vigencia";
        $url = $url . '&PARAM_envio_correo=false&PARAM_tag_adjunto_modulo=true';
        $url = $url . '&PARAM_nombre_reporte=' . str_replace(' ', ':', "$nombreArchivo.xls");
        $this->logMessage($url);
        $ch = curl_init($url);
        //Parametros de retorno en cURL
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); // Skip SSL Verification - 20200407::LAVILA
        //Ejecuta la petición
        $rta = curl_exec($ch);
        //Se cierra la conexión
        curl_close($ch);*/
    }
}
